Submitted By:            Armin K. <krejzi at email dot com>
Date:                    2014-07-14
Initial Package Version: 2.7.8
Upstream Status:         Unknown
Origin:                  Self
Description:             Adds Berkeley DB 6.1 support

--- a/setup.py	2014-06-30 04:05:48.000000000 +0200
+++ b/setup.py	2014-07-13 20:53:42.785228801 +0200
@@ -883,7 +883,7 @@
         # a release.  Most open source OSes come with one or more
         # versions of BerkeleyDB already installed.
 
-        max_db_ver = (5, 3)
+        max_db_ver = (6, 1)
         min_db_ver = (4, 3)
         db_setup_debug = False   # verbose debug prints from this script?
 
@@ -905,7 +905,11 @@
             return True
 
         def gen_db_minor_ver_nums(major):
-            if major == 5:
+            if major == 6:
+                for x in range(max_db_ver[1]+1):
+                    if allow_db_ver((6, x)):
+                        yield x
+            elif major == 5:
                 for x in range(max_db_ver[1]+1):
                     if allow_db_ver((5, x)):
                         yield x